#import "MessLogV2Plugin.h"
#import <SHMesgLog/SHMesgLog.h>

@implementation MessLogV2Plugin
+ (void)registerWithRegistrar:(NSObject<FlutterPluginRegistrar>*)registrar {
    
    FlutterMethodChannel* channel = [FlutterMethodChannel
                                     methodChannelWithName:@"mess_log_tracking_v2"
                                     binaryMessenger:[registrar messenger]];
    MessLogV2Plugin* instance = [[MessLogV2Plugin alloc] init];
    [registrar addMethodCallDelegate:instance channel:channel];
}

- (void)handleMethodCall:(FlutterMethodCall*)call result:(FlutterResult)result {
    if([@"handleAppOpen" isEqualToString:call.method]) {
        [[SHMesgLog shareInstance] handleAppOpen];
    }
    if([@"handleAppQuit" isEqualToString:call.method]) {
        [[SHMesgLog shareInstance] handleAppQuit];
        result(@true);
    }
    if([@"handleAppEnterForeground" isEqualToString:call.method]) {
        [[SHMesgLog shareInstance] handleAppEnterForeground];
        result(@true);
    }
    if([@"handleAppWillTerminate" isEqualToString:call.method]) {
        [[SHMesgLog shareInstance]  handleAppWillTerminate];
        result(@true);
    }
    if ([@"getLibVersion" isEqualToString:call.method]) {
        result([[SHMesgLog shareInstance] getVersion]);
    }else if([@"getDeviceId" isEqualToString:call.method]){
        result([[SHMesgLog shareInstance] getDeviceID]);
    }else if([@"sendLogConfirm" isEqualToString:call.method]){
        NSString* ext = call.arguments[@"ext"];
        [[SHMesgLog shareInstance] sendLogConfirm:ext];
        result(@true);
    }else if([@"sendLogTrackingView" isEqualToString:call.method]){
        NSString* cov = call.arguments[@"cov"];
        NSInteger covInt=(int) cov;
        
        NSString* domain = call.arguments[@"domain"];
        NSString* curl = call.arguments[@"curl"];
        NSString* rurl = call.arguments[@"rurl"];
        NSString* vid = call.arguments[@"vid"];
        NSString* ltype = call.arguments[@"ltype"];
        NSInteger ltypeInt=(int) ltype;
        NSString* boxid = call.arguments[@"boxid"];
        NSString* dspid = call.arguments[@"dspid"];
        NSString* algid = call.arguments[@"algid"];
        NSString* ext = call.arguments[@"ext"];
        
        
        SHLogParams* logParams = [[SHLogParams alloc] init];
        [logParams setDomain:(domain)];
        COVType covType = viewType;
        switch (covInt) {
            case 0:
                covType = viewType;
                break;
            case 1:
                covType = clickType;
                break;
            case 2:
                covType = scrollType;
                break;
        }
        LOGType logType = pageviewLog;
        switch (ltypeInt) {
            case 0:
                logType = pageviewLog;
                break;
            case 1:
                logType = pageviewLog;
                break;
            case 2:
                logType = revLog;
                break;
            case 3:
                logType = boxviewLog;
                break;
        }
        
        [logParams setCov:covType];
        [logParams setCurl:(curl)];
        [logParams setRurl:(rurl)];
        [logParams setVid:(vid)];
        [logParams setLtype:logType];
        [logParams setBoxid:(boxid)];
        [logParams setDspid:(dspid)];
        [logParams setAlgid:(algid)];
        [logParams setExt:(ext)];

        BOOL rs = [[SHMesgLog shareInstance] sendLogTrackingView:logParams];
        result(@(rs));
        
    }else if([@"sendLogClickBanner" isEqualToString:call.method]){
        NSString* appId = call.arguments[@"app_id"];
        NSString* current_activity = call.arguments[@"current_activity"];
        NSInteger current_action = [call.arguments[@"current_action"] intValue];
        [[SHMesgLog shareInstance] sendLogClickBanner:appId org:current_activity cov:current_action];
        result(@true);
    }else {
        result(FlutterMethodNotImplemented);
    }
}

@end
